<!doctype html>
<html lang="en">

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Live Username Availability Check with xhr (Client Side ) and PHP (Server Side)</title>
	<meta name="description" content="">
	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
</head>
<body>
	<div class="container">
		<div class="row">
			<div class="col-sm-12">
				<h2>Live Username Availability Check with XHR <br>
				<small>(Client Side ) and PHP (Server Side) by POST Method </small></h2>
			</div>
		</div>
		<div class="row">
			<div class="col-sm-6">
					<form id="myform" name="myform">
					<div class="form-group">
					<input type="text" name="username" id="username" value="" class="form-control" onchange="checkUsername()" />
					<span id="myuname"> </span><br>
					<p><small>Note: If you enter: 'ram' or 'manohar' or 'tom' or 'rakesh' or 'ajay, you will get message - "username exist."</small></p>
					</div>
					</form>	
			</div>
			<div class="col-sm-6">
			</div>
		</div> <!-- row div close -->
	</div> <!-- container div close -->



	<script src="serialize-0.2.js"></script>
	<script>
		////////////////////////////////////  BOF JS  //////////////////////////////////////////////
		function checkUsername(){

		// Let us create a new XMLHttpRequest object
		 xhr = new XMLHttpRequest();

		//  Let us specify the type of request that we send tp server
		xhr.open('POST', 'username-post-method-response.php', true);
		
        // Send the proper header information along with the request
        xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');

		// Send request with serialized form data
	  	 	params = serialize(myform);
			console.log(params);
			xhr.send(params);

		// Callback function is executed after the response from server is over
		xhr.onload = function() {
		// Check if HTTP response tatus is 200 and browser has got response from server
			if (xhr.status != 200 && xhr.readyState == 4 ) {
				
				// If POST URL is not found then 404: Not Found error
				console.log(`Error ${xhr.status}: ${xhr.statusText}`); 

			// Display server response 
			} else { 
				rdata = JSON.parse(this.responseText);
				console.log(`Done, got ${xhr.response.length} bytes`); 
				document.getElementById("myuname").innerHTML = rdata.msg;
				if(rdata.success == false){
					// username does not exist
					document.getElementById("myuname").className = 'text-success';
					
				}
				else
				{
					// username exists. We add bootstrap class text-danger to show alert and set value of username input field to blank.
					document.getElementById("myuname").className = 'text-danger';
					document.getElementById("username").value = '';
				}
				//alert(rdata.success);
			}
		};

		// event e
		xhr.onprogress = function(event) {
			if (event.lengthComputable) {
				console.log(`Got ${event.loaded} of ${event.total} bytes`);
			} else {
				// If no Content-Length 
				console.log(`Got ${event.loaded} bytes`); 
			}

		};

		xhr.onerror = function() 
		{
			alert("Request failed");
		};
	}
		////////////////////////////////////  EOF JS  //////////////////////////////////////////////
	</script>

</body>

</html>